#[doc = "Register `ISER` reader"]
pub struct R(crate::R<ISER_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<ISER_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<ISER_SPEC>> for R {
    fn from(reader: crate::R<ISER_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `ISER` writer"]
pub struct W(crate::W<ISER_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<ISER_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<ISER_SPEC>> for W {
    fn from(writer: crate::W<ISER_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `SETENA` writer - Enables, or reads the enabled state of one or more interrupts. Each bit corresponds to the same numbered interrupt."]
pub struct SETENA_W<'a> {
    w: &'a mut W,
}
impl<'a> SETENA_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u32) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xffff_ffff) | (value as u32 & 0xffff_ffff);
        self.w
    }
}
impl W {
    #[doc = "Bits 0:31 - Enables, or reads the enabled state of one or more interrupts. Each bit corresponds to the same numbered interrupt."]
    #[inline(always)]
    pub fn setena(&mut self) -> SETENA_W {
        SETENA_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Interrupt Set-Enable Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [iser](index.html) module"]
pub struct ISER_SPEC;
impl crate::RegisterSpec for ISER_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [iser::R](R) reader structure"]
impl crate::Readable for ISER_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [iser::W](W) writer structure"]
impl crate::Writable for ISER_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets ISER to value 0"]
impl crate::Resettable for ISER_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
